# Designed December 2009 by C.plassais + Pilou

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is forbidden:

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Eclate_Deplace
# Original Date	:  03 Juil 2009 version 0.0 (thx to TIG, Thomthom)
# Type			:   Plugin
# Description	:   Exploding movements of groups or/and components 
# Usage			:   Right Click - Context Menu
# Version 0.3
#---------------------------------------------------------------------------------------
#petit plug d'"explosion dplacement" de groupes ou de composants

require 'sketchup.rb'
def pilou_explose
model = Sketchup.active_model
entities = model.entities
selection = model.selection
ss = selection

    if selection.empty?
    UI.messagebox "Veuillez Slectionner des\nComposants ou des Groupes"
    end
    
model.start_operation "Deplacement Eclate"
group = model.active_entities.add_group(ss)
center1 = group.bounds.center
entities.add_cpoint(center1)
result = UI.messagebox "Voulez vous faire une copie de l'original", MB_YESNO
    if result == 6
        group2 = group.copy
        group2.explode
    end
selection = group.explode
xp = center1[0]   # dtermination 
yp = center1[1]   # du centre de
zp = center1[2]   # la slection
prompts = ["Dplacement pivot x", "Dplacement pivot y", "Dplacement pivot z", "Coef translation x de 0 ...", "Coef translation y de 0 ...", "Coef translation z de 0 ...", "Groupe Composant les 2"]
values = [xp, yp, zp, 1, 1, 1, "Les 2"]
list = ["", "", "", "", "", "" , "Groupe|Composant|Les 2"]
results = UI.inputbox prompts, values, list, "Parametres"
return if not results
xpn, ypn, zpn, qx, qy, qz, gc = results

    if model.options["UnitsOptions"]["LengthUnit"]==0
        
        qx = qx.to_i.inch # Translation sur l'axe x
        qy = qy.to_i.inch  # Translation sur l'axe y
        qz = qz.to_i.inch  # Translation sur l'axe z
        
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==1

        qx = qx.to_i.feet # Translation sur l'axe x
        qy = qy.to_i.feet  # Translation sur l'axe y
        qz = qz.to_i.feet  # Translation sur l'axe z
        
    end
    if model.options["UnitsOptions"]["LengthUnit"]==2
        
        qx = qx.to_i.mm # Translation sur l'axe x
        qy = qy.to_i.mm  # Translation sur l'axe y
        qz = qz.to_i.mm  # Translation sur l'axe z
        
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==3
        
        qx = qx.to_i.cm # Translation sur l'axe x
        qy = qy.to_i.cm # Translation sur l'axe y
        qz = qz.to_i.cm # Translation sur l'axe z
        
    end
    
    if model.options["UnitsOptions"]["LengthUnit"]==4
        
        qx = qx.to_i.m # Translation sur l'axe x
        qy = qy.to_i.m  # Translation sur l'axe y
        qz = qz.to_i.m  # Translation sur l'axe z
        
    end 

entities.add_cpoint [xpn,ypn,zpn]
entities.add_cline [xp, yp, zp],[xpn, ypn, zpn]

xpd =  xpn-xp  # Calcul de la distance entre
ypd =  ypn-yp # le centre d'origine de la slection
zpd =  zpn-zp # et le nouveau (=0 si aucun changement)

	if gc == "Groupe"
	gc = Sketchup::Group
	cc = Sketchup::Group
	elsif gc == "Composant"
	gc = Sketchup::ComponentInstance
	cc = Sketchup::ComponentInstance
	elsif gc == "Les 2"
	gc = Sketchup::Group
	cc = Sketchup::ComponentInstance	
	end

	selection.each do |e| # dbut de la boucle de dplacement des objets

	next unless (e.is_a? gc) or next unless(e.is_a? cc)
	center = e.bounds.center
	xc = center[0].to_i  # Determination 
	yc = center[1].to_i  # du centre
	zc = center[2].to_i  # de l'objet
	
    # entities.add_cpoint [xc, yc, zc]
    	
	xpc = xc-xp   # Calcul de la distance
	ypc = yc-yp   # entre le centre d'origine
	zpc = zc-zp   # et le centre de l'objet

	if xc==xp
    xe = xpd
    else
    xe = (xpc*qx)+xpd
    end

    if yc==yp
    ye = ypd 
    else
    ye = (ypc*qy)+ypd
    end

    if zc==zp
     ze = zpd 
    else
    ze = (zpc*qz)+zpd
    end
   	
	point = Geom::Point3d.new xe,ye,ze
	t = Geom::Transformation.new point
	e.transform!(t)

	end
model.commit_operation
end

	if( not file_loaded?("Eclate_Deplace.rb") )
	UI.add_context_menu_handler do |context_menu|
	context_menu.add_separator
	context_menu.add_item("Eclate_Deplace") { pilou_explose }
	end
	file_loaded("Eclate_Deplace.rb")
	end
